/* A Bison parser, made from gram.y
   by GNU bison 1.35.  */

#define YYBISON 1  /* Identify Bison output.  */

# define	ACT_ACCEPT	257
# define	ACT_REJECT	258
# define	ACT_TEMPFAIL	259
# define	ACT_CONTINUE	260
# define	ACT_DISCARD	261
# define	ADD	262
# define	REPLACE	263
# define	DELETE	264
# define	IF	265
# define	FI	266
# define	ELSE	267
# define	ELIF	268
# define	ON	269
# define	HOST	270
# define	FOR	271
# define	FROM	272
# define	AS	273
# define	DO	274
# define	DONE	275
# define	POLL	276
# define	MATCHES	277
# define	FNMATCHES	278
# define	WHEN	279
# define	HOSTNAME	280
# define	RELAYED	281
# define	RATE	282
# define	NEXT	283
# define	STRING	284
# define	CODE	285
# define	XCODE	286
# define	SYMBOL	287
# define	OR	288
# define	AND	289
# define	EQ	290
# define	NE	291
# define	NOT	292

#line 1 "gram.y"

/* This file is part of mailfrom filter.
   Copyright (C) 2005, Sergey Poznyakoff

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
   MA 02110-1301 USA */

#ifdef HAVE_CONFIG_H
# include <config.h>
#endif

#include <fnmatch.h>
#include <setjmp.h>
#include <netdb.h>
#include "mailfrom.h"

NODE *alloc_node(enum node_type type, const struct locus *locus);
int string_to_stat(char *, mf_status *);
void set_poll_arg(struct poll_node *poll, int kw, NODE *var);
static int time_multiplier(const char *, unsigned *, unsigned *);
 
static NODE *root_node;
static int regex_flags; /* Should default to REG_NOSUB ? */
 

#line 39 "gram.y"
#ifndef YYSTYPE
typedef union {
	char *string;
	struct {
		NODE *head;
 		NODE *tail;
	} stmtlist;
	NODE *node;
	struct return_node ret;
	struct poll_node poll;
	struct {
		struct poll_action *head, *tail;
	} actionlist;
	struct locus locus;
	struct {
		int kw;
		NODE *var;
	} arg;
	double number;
} yystype;
# define YYSTYPE yystype
# define YYSTYPE_IS_TRIVIAL 1
#endif
#ifndef YYDEBUG
# define YYDEBUG 1
#endif



#define	YYFINAL		107
#define	YYFLAG		-32768
#define	YYNTBASE	43

/* YYTRANSLATE(YYLEX) -- Bison token number corresponding to YYLEX. */
#define YYTRANSLATE(x) ((unsigned)(x) <= 292 ? yytranslate[x] : 66)

/* YYTRANSLATE[YYLEX] -- Bison token number corresponding to YYLEX. */
static const char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      39,    40,     2,     2,     2,     2,     2,    41,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    42,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38
};

#if YYDEBUG
static const short yyprhs[] =
{
       0,     0,     2,     4,     7,     9,    11,    14,    17,    20,
      22,    24,    26,    30,    34,    37,    38,    40,    42,    45,
      49,    52,    54,    56,    62,    63,    68,    71,    75,    79,
      83,    87,    91,    95,    98,   102,   105,   110,   111,   114,
     117,   119,   122,   125,   126,   128,   130,   136,   139,   141,
     144,   146,   149,   152,   155,   158,   160,   163,   168,   170,
     174,   176,   178
};
static const short yyrhs[] =
{
      44,     0,    45,     0,    44,    45,     0,    49,     0,    46,
       0,     3,    47,     0,     4,    47,     0,     5,    47,     0,
       6,     0,     7,     0,    29,     0,     8,    30,    30,     0,
       9,    30,    30,     0,    10,    30,     0,     0,    48,     0,
      31,     0,    31,    32,     0,    31,    32,    30,     0,    31,
      30,     0,    50,     0,    58,     0,    11,    52,    44,    51,
      12,     0,     0,    14,    52,    44,    51,     0,    13,    44,
       0,    65,    36,    65,     0,    65,    37,    65,     0,    65,
      23,    65,     0,    65,    24,    65,     0,    52,    34,    52,
       0,    52,    35,    52,     0,    38,    52,     0,    39,    52,
      40,     0,    27,    65,     0,    28,    65,    57,    53,     0,
       0,    41,    57,     0,    41,    54,     0,    55,     0,    54,
      55,     0,    56,    30,     0,     0,    57,     0,    31,     0,
      15,    59,    20,    62,    21,     0,    22,    60,     0,    61,
       0,    60,    61,     0,    65,     0,    17,    65,     0,    16,
      65,     0,    19,    65,     0,    18,    65,     0,    63,     0,
      62,    63,     0,    25,    64,    42,    44,     0,    30,     0,
      64,    34,    30,     0,    30,     0,    33,     0,    26,    65,
       0
};

#endif

#if YYDEBUG
/* YYRLINE[YYN] -- source line where rule number YYN was defined. */
static const short yyrline[] =
{
       0,    83,    89,    94,   102,   103,   106,   112,   118,   124,
     129,   134,   138,   145,   152,   160,   164,   167,   173,   179,
     185,   193,   194,   197,   206,   210,   217,   223,   230,   237,
     262,   269,   276,   283,   289,   293,   298,   306,   310,   314,
     320,   321,   327,   338,   342,   345,   357,   365,   371,   376,
     383,   388,   393,   398,   403,   411,   412,   420,   431,   449,
     471,   476,   481
};
#endif


#if (YYDEBUG) || defined YYERROR_VERBOSE

/* YYTNAME[TOKEN_NUM] -- String name of the token TOKEN_NUM. */
static const char *const yytname[] =
{
  "$", "error", "$undefined.", "ACT_ACCEPT", "ACT_REJECT", "ACT_TEMPFAIL", 
  "ACT_CONTINUE", "ACT_DISCARD", "ADD", "REPLACE", "DELETE", "IF", "FI", 
  "ELSE", "ELIF", "ON", "HOST", "FOR", "FROM", "AS", "DO", "DONE", "POLL", 
  "MATCHES", "FNMATCHES", "WHEN", "HOSTNAME", "RELAYED", "RATE", "NEXT", 
  "STRING", "CODE", "XCODE", "SYMBOL", "OR", "AND", "EQ", "NE", "NOT", 
  "'('", "')'", "'/'", "':'", "input", "stmtlist", "stmt", "action", 
  "maybe_triplet", "triplet", "condition", "if_cond", "else_cond", "cond", 
  "divisor", "timespec", "time", "factor", "number", "on_cond", 
  "pollstmt", "arglist", "pollarg", "branches", "branch", "values", "var", 0
};
#endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives. */
static const short yyr1[] =
{
       0,    43,    44,    44,    45,    45,    46,    46,    46,    46,
      46,    46,    46,    46,    46,    47,    47,    48,    48,    48,
      48,    49,    49,    50,    51,    51,    51,    52,    52,    52,
      52,    52,    52,    52,    52,    52,    52,    53,    53,    53,
      54,    54,    55,    56,    56,    57,    58,    59,    60,    60,
      61,    61,    61,    61,    61,    62,    62,    63,    64,    64,
      65,    65,    65
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN. */
static const short yyr2[] =
{
       0,     1,     1,     2,     1,     1,     2,     2,     2,     1,
       1,     1,     3,     3,     2,     0,     1,     1,     2,     3,
       2,     1,     1,     5,     0,     4,     2,     3,     3,     3,
       3,     3,     3,     2,     3,     2,     4,     0,     2,     2,
       1,     2,     2,     0,     1,     1,     5,     2,     1,     2,
       1,     2,     2,     2,     2,     1,     2,     4,     1,     3,
       1,     1,     2
};

/* YYDEFACT[S] -- default rule to reduce with in state S when YYTABLE
   doesn't specify something else to do.  Zero means the default is an
   error. */
static const short yydefact[] =
{
       0,    15,    15,    15,     9,    10,     0,     0,     0,     0,
       0,    11,     1,     2,     5,     4,    21,    22,    17,     6,
      16,     7,     8,     0,     0,    14,     0,     0,     0,    60,
      61,     0,     0,     0,     0,     0,     0,     3,    20,    18,
      12,    13,    62,    35,     0,    33,     0,     0,     0,    24,
       0,     0,     0,     0,     0,     0,     0,     0,    47,    48,
      50,     0,    19,    45,    37,    34,    31,    32,     0,     0,
       0,    29,    30,    27,    28,    52,    51,    54,    53,    49,
       0,     0,    55,    43,    36,    26,     0,    23,    58,     0,
      46,    56,    39,    40,     0,    38,    24,     0,     0,    41,
      44,    42,    25,    59,    57,     0,     0,     0
};

static const short yydefgoto[] =
{
     105,    12,    13,    14,    19,    20,    15,    16,    70,    33,
      84,    92,    93,    94,    64,    17,    36,    58,    59,    81,
      82,    89,    34
};

static const short yypact[] =
{
      71,    16,    16,    16,-32768,-32768,    20,    23,    37,    80,
      49,-32768,    71,-32768,-32768,-32768,-32768,-32768,    40,-32768,
  -32768,-32768,-32768,    53,    55,-32768,    15,    15,    15,-32768,
  -32768,    80,    80,    17,    32,    72,    67,-32768,-32768,    69,
  -32768,-32768,-32768,-32768,    66,-32768,     9,    80,    80,     1,
      15,    15,    15,    15,    15,    15,    15,    15,    72,-32768,
  -32768,    76,-32768,-32768,    62,-32768,    74,-32768,    71,    80,
      92,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
      81,    -8,-32768,    66,-32768,    71,    17,-32768,-32768,    -3,
  -32768,-32768,    63,-32768,    82,    84,     1,    85,    71,-32768,
  -32768,-32768,-32768,-32768,    71,   116,   117,-32768
};

static const short yypgoto[] =
{
  -32768,   -32,   -12,-32768,    93,-32768,-32768,-32768,    24,   -29,
  -32768,-32768,    29,-32768,   -54,-32768,-32768,-32768,    64,-32768,
      42,-32768,     7
};


#define	YYLAST		123


static const short yytable[] =
{
      37,    49,    45,    46,     1,     2,     3,     4,     5,     6,
       7,     8,     9,    90,    68,    69,    10,    80,    66,    67,
       1,     2,     3,     4,     5,     6,     7,     8,     9,    95,
      11,    97,    10,    42,    43,    44,    85,    37,   100,    98,
      86,    26,    60,    47,    48,    29,    11,    18,    30,    65,
      23,    47,    48,    24,    96,    50,    51,    71,    72,    73,
      74,    75,    76,    77,    78,    60,   104,    25,    52,    53,
      38,    35,    39,    37,     1,     2,     3,     4,     5,     6,
       7,     8,     9,    40,    37,    41,    10,    61,    54,    55,
      56,    57,    37,   -43,    63,    21,    22,    63,    26,    62,
      11,    80,    29,    83,    87,    30,    26,    27,    28,    48,
      29,    88,   101,    30,   -44,   103,   106,   107,    31,    32,
     102,    99,    79,    91
};

static const short yycheck[] =
{
      12,    33,    31,    32,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    21,    13,    14,    15,    25,    47,    48,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    83,
      29,    34,    15,    26,    27,    28,    68,    49,    92,    42,
      69,    26,    35,    34,    35,    30,    29,    31,    33,    40,
      30,    34,    35,    30,    86,    23,    24,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    98,    30,    36,    37,
      30,    22,    32,    85,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    30,    96,    30,    15,    20,    16,    17,
      18,    19,   104,    30,    31,     2,     3,    31,    26,    30,
      29,    25,    30,    41,    12,    33,    26,    27,    28,    35,
      30,    30,    30,    33,    30,    30,     0,     0,    38,    39,
      96,    92,    58,    81
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/share/bison/bison.simple"

/* Skeleton output parser for bison,

   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002 Free Software
   Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser when
   the %semantic_parser declaration is not specified in the grammar.
   It was written by Richard Stallman by simplifying the hairy parser
   used when %semantic_parser is specified.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

#if ! defined (yyoverflow) || defined (YYERROR_VERBOSE)

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# if YYSTACK_USE_ALLOCA
#  define YYSTACK_ALLOC alloca
# else
#  ifndef YYSTACK_USE_ALLOCA
#   if defined (alloca) || defined (_ALLOCA_H)
#    define YYSTACK_ALLOC alloca
#   else
#    ifdef __GNUC__
#     define YYSTACK_ALLOC __builtin_alloca
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC malloc
#  define YYSTACK_FREE free
# endif
#endif /* ! defined (yyoverflow) || defined (YYERROR_VERBOSE) */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (YYLTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short yyss;
  YYSTYPE yyvs;
# if YYLSP_NEEDED
  YYLTYPE yyls;
# endif
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAX (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# if YYLSP_NEEDED
#  define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE) + sizeof (YYLTYPE))	\
      + 2 * YYSTACK_GAP_MAX)
# else
#  define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
      + YYSTACK_GAP_MAX)
# endif

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAX;	\
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif


#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");			\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).

   When YYLLOC_DEFAULT is run, CURRENT is set the location of the
   first token.  By default, to implement support for ranges, extend
   its range to the last symbol.  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)       	\
   Current.last_line   = Rhs[N].last_line;	\
   Current.last_column = Rhs[N].last_column;
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#if YYPURE
# if YYLSP_NEEDED
#  ifdef YYLEX_PARAM
#   define YYLEX		yylex (&yylval, &yylloc, YYLEX_PARAM)
#  else
#   define YYLEX		yylex (&yylval, &yylloc)
#  endif
# else /* !YYLSP_NEEDED */
#  ifdef YYLEX_PARAM
#   define YYLEX		yylex (&yylval, YYLEX_PARAM)
#  else
#   define YYLEX		yylex (&yylval)
#  endif
# endif /* !YYLSP_NEEDED */
#else /* !YYPURE */
# define YYLEX			yylex ()
#endif /* !YYPURE */


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)
/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
#endif /* !YYDEBUG */

/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif

#ifdef YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif
#endif

#line 315 "/usr/share/bison/bison.simple"


/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
#  define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#  define YYPARSE_PARAM_DECL
# else
#  define YYPARSE_PARAM_ARG YYPARSE_PARAM
#  define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
# endif
#else /* !YYPARSE_PARAM */
# define YYPARSE_PARAM_ARG
# define YYPARSE_PARAM_DECL
#endif /* !YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
# ifdef YYPARSE_PARAM
int yyparse (void *);
# else
int yyparse (void);
# endif
#endif

/* YY_DECL_VARIABLES -- depending whether we use a pure parser,
   variables are global, or local to YYPARSE.  */

#define YY_DECL_NON_LSP_VARIABLES			\
/* The lookahead symbol.  */				\
int yychar;						\
							\
/* The semantic value of the lookahead symbol. */	\
YYSTYPE yylval;						\
							\
/* Number of parse errors so far.  */			\
int yynerrs;

#if YYLSP_NEEDED
# define YY_DECL_VARIABLES			\
YY_DECL_NON_LSP_VARIABLES			\
						\
/* Location data for the lookahead symbol.  */	\
YYLTYPE yylloc;
#else
# define YY_DECL_VARIABLES			\
YY_DECL_NON_LSP_VARIABLES
#endif


/* If nonreentrant, generate the variables here. */

#if !YYPURE
YY_DECL_VARIABLES
#endif  /* !YYPURE */

int
yyparse (YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  /* If reentrant, generate the variables here. */
#if YYPURE
  YY_DECL_VARIABLES
#endif  /* !YYPURE */

  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yychar1 = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack. */
  short	yyssa[YYINITDEPTH];
  short *yyss = yyssa;
  register short *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;

#if YYLSP_NEEDED
  /* The location stack.  */
  YYLTYPE yylsa[YYINITDEPTH];
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;
#endif

#if YYLSP_NEEDED
# define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
# define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  YYSIZE_T yystacksize = YYINITDEPTH;


  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
#if YYLSP_NEEDED
  YYLTYPE yyloc;
#endif

  /* When reducing, the number of symbols on the RHS of the reduced
     rule. */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;
#if YYLSP_NEEDED
  yylsp = yyls;
#endif
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  */
# if YYLSP_NEEDED
	YYLTYPE *yyls1 = yyls;
	/* This used to be a conditional around just the two extra args,
	   but that might be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yyls1, yysize * sizeof (*yylsp),
		    &yystacksize);
	yyls = yyls1;
# else
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);
# endif
	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;

      {
	short *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);
# if YYLSP_NEEDED
	YYSTACK_RELOCATE (yyls);
# endif
# undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
#if YYLSP_NEEDED
      yylsp = yyls + yysize - 1;
#endif

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yychar1 = YYTRANSLATE (yychar);

#if YYDEBUG
     /* We have to keep this `#if YYDEBUG', since we use variables
	which are defined only if `YYDEBUG' is set.  */
      if (yydebug)
	{
	  YYFPRINTF (stderr, "Next token is %d (%s",
		     yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise
	     meaning of a token, for further debugging info.  */
# ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
# endif
	  YYFPRINTF (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %d (%s), ",
	      yychar, yytname[yychar1]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#if YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to the semantic value of
     the lookahead token.  This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

#if YYLSP_NEEDED
  /* Similarly for the default location.  Let the user run additional
     commands if for instance locations are ranges.  */
  yyloc = yylsp[1-yylen];
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
#endif

#if YYDEBUG
  /* We have to keep this `#if YYDEBUG', since we use variables which
     are defined only if `YYDEBUG' is set.  */
  if (yydebug)
    {
      int yyi;

      YYFPRINTF (stderr, "Reducing via rule %d (line %d), ",
		 yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (yyi = yyprhs[yyn]; yyrhs[yyi] > 0; yyi++)
	YYFPRINTF (stderr, "%s ", yytname[yyrhs[yyi]]);
      YYFPRINTF (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif

  switch (yyn) {

case 1:
#line 84 "gram.y"
{
		     root_node = yyvsp[0].stmtlist.head;
	     }
    break;
case 2:
#line 90 "gram.y"
{
		     yyvsp[0].node->next = NULL;
		     yyval.stmtlist.head = yyval.stmtlist.tail = yyvsp[0].node;
	     }
    break;
case 3:
#line 95 "gram.y"
{
		     yyvsp[-1].stmtlist.tail->next = yyvsp[0].node;
		     yyvsp[-1].stmtlist.tail = yyvsp[0].node;
		     yyval.stmtlist = yyvsp[-1].stmtlist;
	     }
    break;
case 6:
#line 107 "gram.y"
{
		     yyval.node = alloc_node(node_type_return, &yyvsp[-1].locus);
		     yyval.node->v.ret = yyvsp[0].ret;
		     yyval.node->v.ret.stat = SMFIS_ACCEPT;
	     }
    break;
case 7:
#line 113 "gram.y"
{
		     yyval.node = alloc_node(node_type_return, &yyvsp[-1].locus);
		     yyval.node->v.ret = yyvsp[0].ret;
		     yyval.node->v.ret.stat = SMFIS_REJECT;
	     }
    break;
case 8:
#line 119 "gram.y"
{
		     yyval.node = alloc_node(node_type_return, &yyvsp[-1].locus);
		     yyval.node->v.ret = yyvsp[0].ret;
		     yyval.node->v.ret.stat = SMFIS_TEMPFAIL;
	     }
    break;
case 9:
#line 125 "gram.y"
{
		     yyval.node = alloc_node(node_type_return, &yyvsp[0].locus);
		     yyval.node->v.ret.stat = SMFIS_CONTINUE;
	     }
    break;
case 10:
#line 130 "gram.y"
{
		     yyval.node = alloc_node(node_type_return, &yyvsp[0].locus);
		     yyval.node->v.ret.stat = SMFIS_DISCARD;
	     }
    break;
case 11:
#line 135 "gram.y"
{
		     yyval.node = alloc_node(node_type_next, &yyvsp[0].locus);
	     }
    break;
case 12:
#line 139 "gram.y"
{
		     yyval.node = alloc_node(node_type_header, &yyvsp[-2].locus);
		     yyval.node->v.hdr.opcode = header_add;
		     yyval.node->v.hdr.name = yyvsp[-1].string;
		     yyval.node->v.hdr.value = yyvsp[0].string;
	     }
    break;
case 13:
#line 146 "gram.y"
{
		     yyval.node = alloc_node(node_type_header, &yyvsp[-2].locus);
		     yyval.node->v.hdr.opcode = header_replace;
		     yyval.node->v.hdr.name = yyvsp[-1].string;
		     yyval.node->v.hdr.value = yyvsp[0].string;
	     }
    break;
case 14:
#line 153 "gram.y"
{
		     yyval.node = alloc_node(node_type_header, &yyvsp[-1].locus);
		     yyval.node->v.hdr.opcode = header_delete;
		     yyval.node->v.hdr.name = yyvsp[0].string;
	     }
    break;
case 15:
#line 161 "gram.y"
{
		     memset(&yyval.ret, 0, sizeof yyval.ret);
	     }
    break;
case 17:
#line 168 "gram.y"
{
		     yyval.ret.code = yyvsp[0].string;
		     yyval.ret.xcode = NULL;
		     yyval.ret.message = NULL;
	     }
    break;
case 18:
#line 174 "gram.y"
{
		     yyval.ret.code = yyvsp[-1].string;
		     yyval.ret.xcode = yyvsp[0].string;
		     yyval.ret.message = NULL;
	     }
    break;
case 19:
#line 180 "gram.y"
{
		     yyval.ret.code = yyvsp[-2].string;
		     yyval.ret.xcode = yyvsp[-1].string;
		     yyval.ret.message = yyvsp[0].string;
	     }
    break;
case 20:
#line 186 "gram.y"
{
		     yyval.ret.code = yyvsp[-1].string;
		     yyval.ret.xcode = NULL;
		     yyval.ret.message = yyvsp[0].string;
	     }
    break;
case 23:
#line 198 "gram.y"
{
		     yyval.node = alloc_node(node_type_if, &yyvsp[-4].locus);
		     yyval.node->v.cond.cond = yyvsp[-3].node;
		     yyval.node->v.cond.if_true = yyvsp[-2].stmtlist.head;
		     yyval.node->v.cond.if_false = yyvsp[-1].node;
	     }
    break;
case 24:
#line 207 "gram.y"
{
		     yyval.node = NULL;
	     }
    break;
case 25:
#line 211 "gram.y"
{
		     yyval.node = alloc_node(node_type_if, &yyvsp[-3].locus);
		     yyval.node->v.cond.cond = yyvsp[-2].node;
		     yyval.node->v.cond.if_true = yyvsp[-1].stmtlist.head;
		     yyval.node->v.cond.if_false = yyvsp[0].node;
	     }
    break;
case 26:
#line 218 "gram.y"
{
		     yyval.node = yyvsp[0].stmtlist.head;
	     }
    break;
case 27:
#line 224 "gram.y"
{
		     yyval.node = alloc_node(node_type_bin, &yyvsp[-1].locus);
		     yyval.node->v.bin.opcode = bin_eq;
		     yyval.node->v.bin.arg[0] = yyvsp[-2].node;
		     yyval.node->v.bin.arg[1] = yyvsp[0].node;
	     }
    break;
case 28:
#line 231 "gram.y"
{
		     yyval.node = alloc_node(node_type_bin, &yyvsp[-1].locus);
		     yyval.node->v.bin.opcode = bin_ne;
		     yyval.node->v.bin.arg[0] = yyvsp[-2].node;
		     yyval.node->v.bin.arg[1] = yyvsp[0].node;
	     }
    break;
case 29:
#line 238 "gram.y"
{
		     yyval.node = alloc_node(node_type_bin, &yyvsp[-1].locus);
		     if (yyvsp[0].node->type == node_type_string) {
			     int rc;
			     
			     yyval.node->v.re.opcode = bin_regex;
			     yyval.node->v.re.arg = yyvsp[-2].node;
			     rc = regcomp(&yyval.node->v.re.regex, yyvsp[0].node->v.string,
					  regex_flags);
			     if (rc) {
				     char errbuf[512];
				     regerror(rc, &yyval.node->v.re.regex, errbuf,
					      sizeof(errbuf));
				     parse_error("Cannot compile regex: %s",
						 errbuf);
				     YYERROR;

			     }
		     } else {
			     yyval.node->v.bin.opcode = bin_match;
			     yyval.node->v.bin.arg[0] = yyvsp[-2].node;
			     yyval.node->v.bin.arg[1] = yyvsp[0].node;
		     }
	     }
    break;
case 30:
#line 263 "gram.y"
{
		     yyval.node = alloc_node(node_type_bin, &yyvsp[-1].locus);
		     yyval.node->v.bin.opcode = bin_fnmatch;
		     yyval.node->v.bin.arg[0] = yyvsp[-2].node;
		     yyval.node->v.bin.arg[1] = yyvsp[0].node;
	     }
    break;
case 31:
#line 270 "gram.y"
{
		     yyval.node = alloc_node(node_type_bin, &yyvsp[-1].locus);
		     yyval.node->v.bin.opcode = bin_or;
		     yyval.node->v.bin.arg[0] = yyvsp[-2].node;
		     yyval.node->v.bin.arg[1] = yyvsp[0].node;
	     }
    break;
case 32:
#line 277 "gram.y"
{
		     yyval.node = alloc_node(node_type_bin, &yyvsp[-1].locus);
		     yyval.node->v.bin.opcode = bin_and;
		     yyval.node->v.bin.arg[0] = yyvsp[-2].node;
		     yyval.node->v.bin.arg[1] = yyvsp[0].node;
	     }
    break;
case 33:
#line 284 "gram.y"
{
		     yyval.node = alloc_node(node_type_un, &yyvsp[-1].locus);
		     yyval.node->v.un.opcode = unary_not;
		     yyval.node->v.un.arg = yyvsp[0].node;
	     }
    break;
case 34:
#line 290 "gram.y"
{
		     yyval.node = yyvsp[-1].node;
	     }
    break;
case 35:
#line 294 "gram.y"
{
		     yyval.node = alloc_node(node_type_relayed_domain, &yyvsp[-1].locus);
		     yyval.node->v.node = yyvsp[0].node;
	     }
    break;
case 36:
#line 299 "gram.y"
{
		     yyval.node = alloc_node(node_type_rate, get_locus());
		     yyval.node->v.rate.email = yyvsp[-2].node;
		     yyval.node->v.rate.limit = yyvsp[-1].number / yyvsp[0].number;
	     }
    break;
case 37:
#line 307 "gram.y"
{
		     yyval.number = 1;
	     }
    break;
case 38:
#line 311 "gram.y"
{
		     yyval.number = yyvsp[0].number;
	     }
    break;
case 39:
#line 315 "gram.y"
{
		     yyval.number = yyvsp[0].number;
	     }
    break;
case 41:
#line 322 "gram.y"
{
		     yyval.number = yyvsp[-1].number + yyvsp[0].number;
	     }
    break;
case 42:
#line 328 "gram.y"
{
		     unsigned m;
		     if (time_multiplier(yyvsp[0].string, &m, NULL)) {
			     parse_error("Invalid time unit: %s", yyvsp[0].string);
			     YYERROR;
		     }
		     yyval.number = yyvsp[-1].number * m;
	     }
    break;
case 43:
#line 339 "gram.y"
{
		     yyval.number = 1;
	     }
    break;
case 45:
#line 346 "gram.y"
{
		     char *p;
		     yyval.number = strtod(yyvsp[0].string, &p);
		     if (*p) {
			     /* should not happen */
			     parse_error("Invalid number (near `%s')", p);
			     YYERROR;
		     }
	     }
    break;
case 46:
#line 358 "gram.y"
{
		     yyval.node = alloc_node(node_type_poll, &yyvsp[-4].locus);
		     yyval.node->v.poll = yyvsp[-3].poll;
		     yyval.node->v.poll.actions = yyvsp[-1].actionlist.head;
	     }
    break;
case 47:
#line 366 "gram.y"
{
		     yyval.poll = yyvsp[0].poll;
	     }
    break;
case 48:
#line 372 "gram.y"
{
		     memset(&yyval.poll, 0, sizeof yyval.poll);
		     set_poll_arg(&yyval.poll, yyvsp[0].arg.kw, yyvsp[0].arg.var);
	     }
    break;
case 49:
#line 377 "gram.y"
{
		     set_poll_arg(&yyvsp[-1].poll, yyvsp[0].arg.kw, yyvsp[0].arg.var);
		     yyval.poll = yyvsp[-1].poll;
	     }
    break;
case 50:
#line 384 "gram.y"
{
		     yyval.arg.kw = FOR;
		     yyval.arg.var = yyvsp[0].node;
	     }
    break;
case 51:
#line 389 "gram.y"
{
		     yyval.arg.kw = FOR;
		     yyval.arg.var = yyvsp[0].node;
	     }
    break;
case 52:
#line 394 "gram.y"
{
		     yyval.arg.kw = HOST;
		     yyval.arg.var = yyvsp[0].node;
	     }
    break;
case 53:
#line 399 "gram.y"
{
		     yyval.arg.kw = AS;
		     yyval.arg.var = yyvsp[0].node;
	     }
    break;
case 54:
#line 404 "gram.y"
{
		     yyval.arg.kw = FROM;
		     yyval.arg.var = yyvsp[0].node;
	     }
    break;
case 56:
#line 413 "gram.y"
{
		     yyvsp[-1].actionlist.tail->next = yyvsp[0].actionlist.head;
		     yyvsp[-1].actionlist.tail = yyvsp[0].actionlist.tail;
		     yyval.actionlist = yyvsp[-1].actionlist;
	     }
    break;
case 57:
#line 421 "gram.y"
{
		     struct poll_action *act;
		     for (act = yyvsp[-2].actionlist.head; act; act = act->next) {
			     act->locus = yyvsp[-3].locus;
			     act->node = yyvsp[0].stmtlist.head;
		     }
		     yyval.actionlist = yyvsp[-2].actionlist;
	     }
    break;
case 58:
#line 432 "gram.y"
{
		     mf_status status;

		     if (string_to_stat(yyvsp[0].string, &status)) {
			     parse_error("Unknown return code: %s", yyvsp[0].string);
			     YYERROR;
		     } else {
			     struct poll_action *act = malloc(sizeof *act);
			     if (!act) {
				     parse_error("Not enough memory");
				     abort();
			     }
			     act->next = NULL;
			     act->status = status;
			     yyval.actionlist.head = yyval.actionlist.tail = act;
		     }
	     }
    break;
case 59:
#line 450 "gram.y"
{
		     mf_status status;

		     if (string_to_stat(yyvsp[0].string, &status)) {
			     parse_error("Unknown return code: %s", yyvsp[-2].actionlist);
			     YYERROR;
		     } else {
			     struct poll_action *act = malloc(sizeof *act);
			     if (!act) {
				     parse_error("Not enough memory");
				     abort();
			     }
			     act->next = NULL;
			     act->status = status;
			     yyvsp[-2].actionlist.tail->next = act;
			     yyvsp[-2].actionlist.tail = act;
			     yyval.actionlist = yyvsp[-2].actionlist;
		     }
	     }
    break;
case 60:
#line 472 "gram.y"
{
		     yyval.node = alloc_node(node_type_string, get_locus());
		     yyval.node->v.string = yyvsp[0].string;
	     }
    break;
case 61:
#line 477 "gram.y"
{
		     yyval.node = alloc_node(node_type_symbol, get_locus());
		     yyval.node->v.string = yyvsp[0].string;
	     }
    break;
case 62:
#line 482 "gram.y"
{
		     yyval.node = alloc_node(node_type_hostname, get_locus());
		     yyval.node->v.node = yyvsp[0].node;
	     }
    break;
}

#line 705 "/usr/share/bison/bison.simple"


  yyvsp -= yylen;
  yyssp -= yylen;
#if YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG
  if (yydebug)
    {
      short *yyssp1 = yyss - 1;
      YYFPRINTF (stderr, "state stack now");
      while (yyssp1 != yyssp)
	YYFPRINTF (stderr, " %d", *++yyssp1);
      YYFPRINTF (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;
#if YYLSP_NEEDED
  *++yylsp = yyloc;
#endif

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  char *yymsg;
	  int yyx, yycount;

	  yycount = 0;
	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  for (yyx = yyn < 0 ? -yyn : 0;
	       yyx < (int) (sizeof (yytname) / sizeof (char *)); yyx++)
	    if (yycheck[yyx + yyn] == yyx)
	      yysize += yystrlen (yytname[yyx]) + 15, yycount++;
	  yysize += yystrlen ("parse error, unexpected ") + 1;
	  yysize += yystrlen (yytname[YYTRANSLATE (yychar)]);
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "parse error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[YYTRANSLATE (yychar)]);

	      if (yycount < 5)
		{
		  yycount = 0;
		  for (yyx = yyn < 0 ? -yyn : 0;
		       yyx < (int) (sizeof (yytname) / sizeof (char *));
		       yyx++)
		    if (yycheck[yyx + yyn] == yyx)
		      {
			const char *yyq = ! yycount ? ", expecting " : " or ";
			yyp = yystpcpy (yyp, yyq);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yycount++;
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exhausted");
	}
      else
#endif /* defined (YYERROR_VERBOSE) */
	yyerror ("parse error");
    }
  goto yyerrlab1;


/*--------------------------------------------------.
| yyerrlab1 -- error raised explicitly by an action |
`--------------------------------------------------*/
yyerrlab1:
  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;
      YYDPRINTF ((stderr, "Discarding token %d (%s).\n",
		  yychar, yytname[yychar1]));
      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;


/*-------------------------------------------------------------------.
| yyerrdefault -- current state does not do anything special for the |
| error token.                                                       |
`-------------------------------------------------------------------*/
yyerrdefault:
#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */

  /* If its default is to accept any token, ok.  Otherwise pop it.  */
  yyn = yydefact[yystate];
  if (yyn)
    goto yydefault;
#endif


/*---------------------------------------------------------------.
| yyerrpop -- pop the current state because it cannot handle the |
| error token                                                    |
`---------------------------------------------------------------*/
yyerrpop:
  if (yyssp == yyss)
    YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#if YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG
  if (yydebug)
    {
      short *yyssp1 = yyss - 1;
      YYFPRINTF (stderr, "Error: state stack now");
      while (yyssp1 != yyssp)
	YYFPRINTF (stderr, " %d", *++yyssp1);
      YYFPRINTF (stderr, "\n");
    }
#endif

/*--------------.
| yyerrhandle.  |
`--------------*/
yyerrhandle:
  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;
#if YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

/*---------------------------------------------.
| yyoverflowab -- parser overflow comes here.  |
`---------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}
#line 488 "gram.y"


int
yyerror(char *s)
{
	parse_error("%s", s);
}


int
parse_config(char *name, int ydebug, int ldebug)
{
	yydebug = ydebug;
	if (source(name, ldebug))
		return -1;
	return yyparse();
}
	
NODE *
alloc_node(enum node_type type, const struct locus *locus)
{
	NODE *node = malloc(sizeof(*node));
	if (!node) {
		yyerror("Not enough memory");
		abort();
	}
	node->type = type;
	node->locus = *locus;
	node->next = NULL;
	return node;
}
	
int
string_to_stat(char *str, mf_status *status)
{
	if (strcmp(str, "success") == 0)
		*status = mf_success;
	else if (strcmp(str, "not_found") == 0)
		*status = mf_not_found;
	else if (strcmp(str, "failure") == 0)
		*status = mf_failure;
	else if (strcmp(str, "temp_failure") == 0)
		*status = mf_temp_failure;
	else
		return 1;
	return 0;
}


/* Print parse tree */

static void print_node_list(NODE *node, int indent);
static void print_node(NODE *node, int indent);
void print_stat(sfsistat stat);
static int dbg_setreply(void *data, char *code, char *xcode, char *message);
static void dbg_setheader(void *data, struct header_node *hdr);


static char *
mf_status_str(mf_status stat)
{
	switch (stat) {
	case mf_success:
		return "success";
	case mf_not_found:
		return "not_found";
	case mf_failure:
		return "failure";
	case mf_temp_failure:
		return "temp_failure";
	}
	return "UNKNOWN";
}

static void
print_level(int level)
{
	level *= 2;
	printf("%*.*s", level, level, "");
}


static void
print_poll(struct poll_node *poll, int level)
{
	struct poll_action *act;

	print_level(level);
	printf("POLL\n");
	print_level(level+1);
	printf("FOR:\n");
	print_node(poll->email, level+2);
	if (poll->client_addr) {
		print_level(level+1);
		printf("HOST:\n");
		print_node(poll->client_addr, level+2);
	}
	if (poll->mailfrom) {
		print_level(level+1);
		printf("MAIL FROM:\n");
		print_node(poll->mailfrom, level+2);
	}
	if (poll->ehlo) {
		print_level(level+1);
		printf("EHLO:\n");
		print_node(poll->ehlo, level+2);
	}
	
	for (act = poll->actions; act; act = act->next) {
		print_level(level+1);
		printf("when %s:\n", mf_status_str(act->status));
		print_node_list(act->node, level+2);
	}
}

static void
print_bin_op(enum bin_opcode opcode)
{
	char *p;
	switch (opcode) {
	case bin_and:
		p = "AND";
		break;
		
	case bin_or:
		p = "OR";
		break;
		
	case bin_eq:
		p = "EQ";
		break;
		
	case bin_ne:
		p = "NE";
		break;

	case bin_match:
		p = "MATCH";
		break;
		
	case bin_fnmatch:
		p = "FNMATCH";
		break;

	case bin_regex:
		p = "REGEX";
		break;
		
	default:
		p = "UNKNOWN_OP";
	}
	printf("%s", p);
}

static void
print_node(NODE *node, int level)
{
	switch (node->type) {
	case node_type_string:
		print_level(level);
		printf("CONSTANT: %s\n", node->v.string);
		break;
		
	case node_type_symbol:
		print_level(level);
		printf("SYMBOL: %s\n", node->v.string);
		break;
		
	case node_type_if:
		print_level(level);
		printf("COND: \n");
		print_node(node->v.cond.cond, level);
		print_level(level);
		printf("IFTRUE\n");
		print_node_list(node->v.cond.if_true, level+1);
		print_level(level);
		printf("IFFALSE\n");
		print_node_list(node->v.cond.if_false, level+1);
		break;
		
	case node_type_poll:
		print_poll(&node->v.poll, level);
		break;
		
	case node_type_bin:
		print_level(level);
		print_bin_op(node->v.bin.opcode);
		printf("\n");
		print_node(node->v.bin.arg[0], level+1);
		if (node->v.bin.opcode != bin_regex)
			print_node(node->v.bin.arg[1], level+1);
		else {
			print_level(level+1);
			printf("/* COMPILED REGEX */\n");
		}
		break;
		
	case node_type_un:
		print_level(level);
		printf("NOT ");
		print_node(node->v.un.arg, 0);
		break;

	case node_type_next:
		print_level(level);
		printf("next\n");
		break;
		
	case node_type_return:
		if (node->v.ret.code) {
			print_level(level);
			dbg_setreply(NULL, node->v.ret.code,
				     node->v.ret.xcode,
				     node->v.ret.message);
		}
		print_level(level);
		print_stat(node->v.ret.stat);
		printf("\n");
		break;
		
	case node_type_header:
		print_level(level);
		dbg_setheader(NULL, &node->v.hdr);
		break;

	case node_type_hostname:
		print_level(level);
		printf("HOSTNAME\n");
		print_node(node->v.node, level+1);
		break;

	case node_type_relayed_domain:
		print_level(level);
		printf("RELAYED\n");
		print_node(node->v.node, level+1);
		break;
		
	case node_type_rate:
		print_level(level);
		printf("RATE %g\n", node->v.rate.limit);
		print_node(node->v.rate.email, level+1);
		break;
	       
	default:
		abort();
	}		

}	

static void
print_node_list(NODE *node, int level)
{
	for (; node; node = node->next)
		print_node(node, level);
}

void
print_config()
{
	print_node_list(root_node, 0);
}



#define skip_ws(p) while (*(p) && isspace(*(p))) (p)++;
			  
static char *
getword(char **p, char **buf)
{
	int len;
	
	skip_ws(*p);
	if (!**p)
		return NULL;
	for (len = 0; (*p)[len] && !isspace((*p)[len]); len++)
		;
	*buf = malloc(len+1);
	if (*buf) {
		memcpy(*buf, *p, len);
		(*buf)[len] = 0;
	}
	*p += len;
	return *buf;
}

enum regex_mode { regex_enable, regex_disable, regex_set };

static void
pragma_regex(char *text)
{
	char *p, *buf;
	int bit;
	enum regex_mode mode = regex_set;
	
	while (p = getword(&text, &buf)) {
		switch (p[0]) {
		case '+':
			mode = regex_enable;
			p++;
			break;

		case '-':
			mode = regex_disable;
			p++;
			break;

		case '=':
			mode = regex_set;
			p++;
			break;
		}

		if (strcmp (p, "extended") == 0)
			bit = REG_EXTENDED;
		else if (strcmp (p, "icase") == 0)
			bit = REG_ICASE;
		else if (strcmp (p, "newline") == 0)
			bit = REG_NEWLINE;
		else {
			parse_error("Unknown regexp flag: %s", p);
			free(buf);
			return;
		}

		switch (mode) {
		case regex_disable:
			regex_flags &= ~bit;
			break;
		case regex_enable:
			regex_flags |= bit;
			break;
		case regex_set:
			regex_flags = bit;
			break;
		}
		free(buf);
	}
}

static void
pragma_option(char *text)
{
	char *name;
	char *value;
	char *p;
	int len;
	
	if (!getword(&text, &name)) {
		parse_error("Invalid pragma: expected option name");
		return;
	}
	if (!getword(&text, &value)) {
		parse_error("Invalid pragma: expected option value");
		free(name);
		return;
	}

	skip_ws(text);
	if (*text) {
		parse_error("Invalid pragma: junk after the arguments");
		/* Try to handle it anyway */
	}

	p = value;
	len = strlen(p);
	if ((*p == '"' || *p == '\'') && p[len-1] == *p) {
		p[len-1] = 0;
		p++;
	}
		
	if (set_option(name, p, 0)) {
		if (errno == ENOENT)
			parse_error("Unknown pragma option");
		else
			parse_error("Invalid pragma");
	}
	
	free(name);
	free(value);
}

void
parse_pragma(char *text)
{
	char *buf;

	while (*text != '#')
		text++;
	++text;
	skip_ws(text);
	text += 6; /* "pragma" */

	if (!getword(&text, &buf))
		parse_error("Empty pragma");
	else if (strcmp(buf, "regex") == 0)
		pragma_regex(text);
	else if (strcmp(buf, "option") == 0)
		pragma_option(text);
	else
		parse_error("Unknown pragma");
	free(buf);
}


/* Rudimentary dictionary support */
struct dict_entry {
	char *name;
	char *value;
};

static int
name_comp(const void *item, const void *data)
{
	const struct dict_entry *ent = item;
	const struct dict_entry *p = data;
	return strcmp(ent->name, p->name);
}

void
name_destroy(void *item)
{
	const struct dict_entry *ent = item;
	free(ent->name);
	free(ent->value);
}

void
dict_init(list_t *dict)
{
	list_create(dict);
	list_set_comparator(*dict, name_comp);
	list_set_destroy_item (*dict, name_destroy);
}

char *
dict_install(list_t dict, char *name, char *value)
{
	struct dict_entry ent, *p;

	ent.name = name;

	if (list_locate(dict, &ent, (void**)&p) == 0) {
		free(p->value);
		p->value = strdup(value);
	} else {
		p = malloc(sizeof(*p));
		if (!p)
			abort();
		p->name = strdup(name);
		p->value = strdup(value);
		list_append(dict, p);
	}
	return p->value;
}

void
dict_destroy(list_t *dict)
{
	list_destroy(dict);
}

char *
dict_getsym(void *data, char *str)
{
	struct dict_entry ent, *p;
	char *tmp = NULL;
	char *val = NULL;
	
	if (str[0] == '{') {
		int len = strlen(str);
		if (str[len-1] == '}') {
			tmp = malloc(len-1);
			if (!tmp)
				abort();
			memcpy(tmp, str+1, len-2);
			tmp[len-2] = 0;
			str = tmp;
		}
	}
	
	ent.name = str;
	if (list_locate(data, &ent, (void**)&p) == 0)
		val = p->value;
	free(tmp);
	return val;
}




/* Runtime support */

union value {
	int bool;
	char *string;
};

struct eval_environ {
	void *data;
	SMFICTX *ctx;
	char *(*getsym)(void *data, char *str);
	int (*setreply)(void *data, char *code, char *xcode, char *message);
	void (*setheader)(void *data, struct header_node *hdr);

	list_t dict;
	
	/* Exit information */
	sfsistat status;
	jmp_buf x;
};

void eval_node_list(NODE *node, struct eval_environ *env);
void eval_node(NODE *node, struct eval_environ *env, union value *val);

void
eval_poll(NODE *node, struct eval_environ *env)
{
	struct poll_node *poll = &node->v.poll;
	mf_status rc;
	struct poll_action *act;
	union value vemail, vaddr, vehlo, vmailfrom;

	eval_node(poll->email, env, &vemail);
	if (poll->ehlo)
		eval_node(poll->ehlo, env, &vehlo);
	else
		vehlo.string = smtp_domain;
	if (poll->mailfrom)
		eval_node(poll->ehlo, env, &vmailfrom);
	else
		vmailfrom.string = postmaster_email;
	
	if ( poll->client_addr) {
		union value vaddr;
		eval_node(poll->client_addr, env, &vaddr);
		trace("%s:%lu: STRICT POLL FOR %s HOST %s FROM %s AS <%s>",
		      node->locus.file, node->locus.line,
		      vemail.string, vaddr.string,
		      vehlo.string, vmailfrom.string);
		rc = method_strict(env->ctx, vemail.string, vaddr.string,
				   vehlo.string, vmailfrom.string);
	} else {
		trace("%s:%lu: STANDARD POLL FOR %s FROM %s AS <%s>",
		      node->locus.file, node->locus.line,
		      vemail.string, vehlo.string, vmailfrom.string);
		rc = method_standard(env->ctx, vemail.string,
				     vehlo.string, vmailfrom.string);
	}
	
	for (act = poll->actions; act; act = act->next) {
		if (act->status == rc)
			eval_node_list(act->node, env);
	}
}

void
eval_hostname(struct eval_environ *env, union value *val)
{
	char *s = dict_getsym(env->dict, val->string);
	if (!s) {
		char hbuf[NI_MAXHOST];
		if (resolve_ipstr(val->string, hbuf, sizeof(hbuf)) == 0) {
			s = dict_install(env->dict, val->string, hbuf);
		} else
			return; /* val is not changed */
	}
	val->string = s;
}

void
eval_rate(NODE *node, struct eval_environ *env,
	  union value *email, double limit, union value *res)
{
	char *p;
	double rate;

	if (get_rate(email->string, &rate) != mf_success) {
		mu_error("%s:%lu: runtime error: cannot get rate for %s",
			 node->locus.file, node->locus.line, email->string);
env->status = SMFIS_TEMPFAIL;
		longjmp(env->x, 1);
	}

	res->bool = rate > limit;
}

void
eval_node(NODE *node, struct eval_environ *env, union value *val)
{
	union value vtmp;

	switch (node->type) {
	case node_type_string:
		val->string = node->v.string;
		break;
		
	case node_type_symbol:
		val->string = env->getsym(env->data, node->v.string);
		if (!val->string) {
			mu_error("Symbol `%s' is not defined", node->v.string);
			env->status = SMFIS_TEMPFAIL;
			longjmp(env->x, 1);
		}
		break;
		
	case node_type_if:
		eval_node(node->v.cond.cond, env, &vtmp);
		if (vtmp.bool) {
			trace("%s:%lu: MATCHED CONDITION",
			      node->locus.file, node->locus.line);
			eval_node_list(node->v.cond.if_true, env);
		} else
			eval_node_list(node->v.cond.if_false, env);
		break;
		
	case node_type_poll:
		eval_poll(node, env);
		break;
		
	case node_type_bin:
		eval_node(node->v.bin.arg[0], env, &vtmp);
		switch (node->v.bin.opcode) {
		case bin_and:
			if (!vtmp.bool) {
				val->bool = vtmp.bool;
				break;
			}
			eval_node(node->v.bin.arg[1], env, val);
			val->bool &= vtmp.bool;
			break;

		case bin_or:
			if (vtmp.bool) {
				val->bool = vtmp.bool;
				break;
			}
			eval_node(node->v.bin.arg[1], env, val);
			val->bool |= vtmp.bool;
			break;
			
		case bin_eq:
			eval_node(node->v.bin.arg[1], env, val);
			val->bool = strcasecmp(vtmp.string, val->string) == 0;
			break;

		case bin_ne:
			eval_node(node->v.bin.arg[1], env, val);
			val->bool = strcasecmp(vtmp.string, val->string) != 0;
			break;

		case bin_regex:
			val->bool = regexec(&node->v.re.regex, vtmp.string, 0, NULL, 0) == 0;
			break;
			
		case bin_match:
		{
			int rc;
			regex_t re;
			
			eval_node(node->v.bin.arg[1], env, val);
			rc = regcomp(&re, val->string, regex_flags);
			if (rc) {
				char errbuf[512];
				regerror(rc, &re, errbuf, sizeof(errbuf));
				mu_error("runtime error at %s:%lu, compiling regex `%s': %s",
					 val->string,
					 node->locus.file, node->locus.line,
					 errbuf);
				env->status = SMFIS_TEMPFAIL;
				longjmp(env->x, 1);
			}
			val->bool = regexec(&re, vtmp.string, 0, NULL, 0) == 0;
			regfree(&re);
			break;
		}

		case bin_fnmatch:
			eval_node(node->v.bin.arg[1], env, val);
			val->bool = fnmatch (val->string, vtmp.string, 0) == 0;
			break;
		}
		break;
		
	case node_type_un:
		eval_node(node->v.un.arg, env, val);
		val->bool = !val->bool;
		break;

	case node_type_next:
		trace("%s:%lu: next",
		      node->locus.file, node->locus.line);
		break;
		
	case node_type_return:
		trace("%s:%lu: %s %s %s %s",
		      node->locus.file, node->locus.line,
		      sfsistat_str(node->v.ret.stat),
		      node->v.ret.code ? node->v.ret.code : "",
		      node->v.ret.xcode ? node->v.ret.xcode : "",
		      node->v.ret.message ? node->v.ret.message : "");
		env->setreply(env->data,
			      node->v.ret.code,
			      node->v.ret.xcode,
			      node->v.ret.message);
		env->status = node->v.ret.stat;
		longjmp(env->x, 1);
		break;
		
	case node_type_header:
		trace("%s:%lu: %s %s %s",
		      node->locus.file, node->locus.line,
		      header_command_str(node->v.hdr.opcode),
		      node->v.hdr.name,
		      node->v.hdr.value);
		env->setheader(env->data, &node->v.hdr);
		break;

	case node_type_hostname:
		eval_node(node->v.node, env, val);
		eval_hostname(env, val);
		break;

	case node_type_relayed_domain:
		eval_node(node->v.node, env, val);
		val->bool = relayed_domain_p(val->string);
		break;

	case node_type_rate:
		eval_node(node->v.rate.email, env, &vtmp);
		eval_rate(node, env, &vtmp, node->v.rate.limit, val);
		break;
			
	default:
		abort();
	}		
}

void
eval_node_list(NODE *node, struct eval_environ *env)
{
	union value v;
/*	trace("%s:%lu: CONTINUING", node->locus.file, node->locus.line);*/
	for (; node; node = node->next)
		eval_node(node, env, &v);
}


/* Run-time execution */
static char *
ctx_getsym(void *data, char *str)
{
	return smfi_getsymval(data, str);
}

static int
ctx_setreply(void *data, char *code, char *xcode, char *message)
{
	if (code)
		return smfi_setreply(data, code, xcode, message);
	return 0;
}

static void
ctx_setheader(void *data, struct header_node *hdr)
{
	priv_store_header_command(data, hdr);
}

sfsistat
run_program(SMFICTX *ctx)
{
	struct eval_environ env;

	env.data = env.ctx = ctx;
	env.getsym = ctx_getsym;
	env.setreply = ctx_setreply;
	env.setheader = ctx_setheader;
	env.status = SMFIS_CONTINUE;
	dict_init(&env.dict);
	
	if (setjmp(env.x) == 0)
		eval_node_list(root_node, &env);
	dict_destroy(&env.dict);
	return env.status;
}


/* Test run */
struct sfsistat_tab {
	char *name;
	sfsistat stat;
} sfsistat_tab[] = {
	{ "accept", SMFIS_ACCEPT },
	{ "continue", SMFIS_CONTINUE },
	{ "discard", SMFIS_DISCARD },
	{ "reject", SMFIS_REJECT },
	{ "tempfail", SMFIS_TEMPFAIL },
	NULL
};

const char *
sfsistat_str(sfsistat stat)
{
	struct sfsistat_tab *p;
	for (p = sfsistat_tab; p->name; p++)
		if (p->stat == stat) 
			return p->name;
	return NULL;
}

void
print_stat(sfsistat stat)
{
	struct sfsistat_tab *p;
	for (p = sfsistat_tab; p->name; p++)
		if (p->stat == stat) {
			printf("%s", p->name);
			return;
		}
	printf("%d", stat);
}

const char *
header_command_str(enum header_opcode opcode)
{
	switch (opcode) {
	case header_add:
		return "ADD HEADER ";
		
	case header_replace:
		return "REPLACE HEADER ";
		break;

	case header_delete:
		return "DELETE HEADER ";
		break;
	}
	return "UNKNOWN HEADER COMMAND ";
}

static int
dbg_setreply(void *data, char *code, char *xcode, char *message)
{
	if (!code)
		return 0;
	printf("SET REPLY %s", code);
	if (xcode)
		printf(" %s", xcode);
	if (message)
		printf(" %s", message);
	printf("\n");
}

static void
dbg_setheader(void *data, struct header_node *hdr)
{
	printf("SET HEADER %s: %s\n", hdr->name, hdr->value);
}

sfsistat
test_program(list_t dict)
{
	struct eval_environ env;

	env.data = dict;
	env.ctx = NULL;
	env.getsym = dict_getsym;
	env.setreply = dbg_setreply;
	env.setheader = dbg_setheader;
	env.status = SMFIS_CONTINUE;
	dict_init(&env.dict);
	
	if (setjmp(env.x) == 0)
		eval_node_list(root_node, &env);
	dict_destroy(&env.dict);
	
	print_stat(env.status);
	printf("\n");
	
	return env.status;
}

void
set_poll_arg(struct poll_node *poll, int kw, NODE *var)
{
	switch (kw) {
	case FOR:
		poll->email = var;
		break;
		
	case HOST:
		poll->client_addr = var;
		break;
		
	case AS:
		poll->mailfrom = var;
		break;
		
	case FROM:
		poll->ehlo = var;
		break;
		
	default:
		abort();
	}
}
		
static int
time_multiplier(const char *str, unsigned *m, unsigned *plen)
{
	static struct timetab {
		char *name;
		unsigned mul;
	} tab[] = {
		{ "seconds", 1 },
		{ "minutes", 60 },
		{ "hours", 60*60 },
		{ "days",  24*60*60 },
		{ "weeks", 7*24*60*60 },
		{ "months", 31*7*24*60*60 },
		NULL
	};
	struct timetab *p;

	for (p = tab; p->name; p++) {
		if (p->name[0] == tolower(str[0])) {
			int nlen = strlen(p->name);
			int slen = strlen(str);

			if (slen > nlen)
				continue;
			
			if (strncasecmp(p->name, str, slen) == 0) {
				*m = p->mul;
				if (plen)
					*plen = slen;
				return 0;
			}
		}
	}
	return 1;
}

int
convert_rate(const char *arg, double *rate)
{
	double count;
	char *p;

	count = strtod(arg, &p);
	if (*p) {
		char *q;
		double div;

		while (*p && isspace(*p))
			p++;
		switch (*p) {
		case 0:
			break;
		case '/':
			div = 0;
			p++;
			while (*p) {
				unsigned n;
				unsigned m, len;

				while (*p && isspace(*p))
					p++;
				if (isdigit(*p))
					n = strtoul(p, &q, 10);
				else {
					n = 1;
					q = p;
				}
				while (*q && isspace(*q))
					q++;
				if (time_multiplier(q, &m, &len)) {
					mu_error("Invalid interval (near `%s')", q);
					return 1;
				}
				div += n*m;
				p = q + len;
			}
			break;
		default:
			mu_error("Invalid interval (near `%s')", p);
			return 1;
		}

		count /= div;
	}
	*rate = count;
	return 0;
}
		
